<!DOCTYPE html>
<html lang="fr">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Réinitialisation de mot de passe</title>
    <link
      href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css"
      rel="stylesheet"
      integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1"
      crossorigin="anonymous"
    />
    <script src="https://unpkg.com/vue@next"></script>
    <style>
      .card {
        background-color: #fff;
        border-radius: 10px;
        box-shadow: 0px 0px 10px rgba(0, 0, 0, 0.2);
      }

      .card-body {
        padding: 10% 10%;
      }

      h3.card-title {
        text-align: center;
        font-size: 24px;
        color: #ff5733; /* Couleur orange vif */
        font-weight: bold;
        margin-bottom: 2em;
      }

      .btn-primary {
        text-align: center;
        margin-top: 20px;
        background-color: #ff5733;
        color: #fff;
        border: none;
        border-radius: 5px;
        padding: 10px 20px;
        font-size: 18px;
        cursor: pointer;
        text-decoration: none;
        transition: background-color 0.3s;
      }

      .btn-primary:hover {
        background-color: #ff4500;
        color: #fff;
      }

      .form-group {
        position: relative;
      }

      .password-rules {
        position: absolute;
        top: 100%;
        left: 0;
        width: 100%;
        font-size: 14px;
        margin-top: 5px;
        color: green; /* Par défaut, couleur valide */
      }

      .password-rules.invalid {
        color: red;
      }
    </style>
  </head>
  <body>
    <div class="container my-5 py-5" id="app">
      <div class="row">
        <div class="col-md-6 col-sm-12 mx-auto">
          <div class="card">
            <div class="card-body">
              <h3 class="card-title">
                Réinitialisez votre mot de passe maintenant
              </h3>
              <form @submit.prevent="resetPassword" v-if="!done">
                <div class="form-group">
                  <label for="password">Nouveau mot de passe</label>
                  <input
                    type="password"
                    v-model="password"
                    id="password"
                    class="form-control"
                    placeholder="Nouveau mot de passe"
                    @input="checkPasswordRules"
                  />
                </div>
                <div class="form-group mt-3">
                  <label for="confirm_password"
                    >Confirmez le nouveau mot de passe</label
                  >
                  <input
                    type="password"
                    v-model="confirm_password"
                    id="confirm_password"
                    class="form-control"
                    placeholder="Confirmez le mot de passe"
                  />
                </div>

                <small class="text-muted" v-if="password.length > 0">
                  {{ passwordRulesMessage }}
                </small>

                <div class="form-group mt-3">
                  <button class="btn btn-primary" type="submit">
                    Réinitialiser le mot de passe
                  </button>
                </div>
              </form>
              <p v-else>
                Votre réinitialisation de mot de passe a réussi. Veuillez vous
                connecter à votre compte.
              </p>
            </div>
          </div>
        </div>
      </div>
    </div>
    <script>
      const app = Vue.createApp({
        data: () => ({
          done: false,
          password: "",
          confirm_password: "",
          passwordRulesMessage: "",
        }),
        methods: {
          async resetPassword() {
            let { password, confirm_password } = this;
            if (password && password === confirm_password) {
              let resetPasswordToken = window.location.href.split("/").pop();
              // Faire la requête API
              let data = await fetch("/api/users/reset-password-now", {
                method: "POST",
                headers: {
                  "Content-Type": "application/json",
                },
                body: JSON.stringify({ password, resetPasswordToken }),
              }).then((res) => res.json());
              if (data.success) {
                this.done = true;
                setTimeout(() => {
                  window.opener = self;
                  window.close();
                }, 5000);
              }
            }
          },
          checkPasswordRules() {
            const regexUpperCase = /[A-Z]/;
            const regexNumber = /\d/;
            const regexSpecialChar = /[-!$%^&*()_+|~=`{}\[\]:";'<>?,.@#]/;
            const { password } = this;

            let rulesMet = 0;

            if (password.length >= 8) rulesMet++;
            if (regexUpperCase.test(password)) rulesMet++;
            if (regexNumber.test(password)) rulesMet++;
            if (regexSpecialChar.test(password)) rulesMet++;

            switch (rulesMet) {
              case 0:
                this.passwordRulesMessage = "Ajoutez au moins 8 caractères.";
                break;
              case 1:
                this.passwordRulesMessage =
                  "Ajoutez plus de caractères spéciaux.";
                break;
              case 2:
                this.passwordRulesMessage = "Ajoutez au moins un chiffre.";
                break;
              case 3:
                this.passwordRulesMessage = "Ajoutez au moins une majuscule.";
                break;
              case 4:
                this.passwordRulesMessage = "Mot de passe valide.";
                break;
              default:
                this.passwordRulesMessage = "";
            }
          },
        },
      }).mount("#app");
    </script>
  </body>
</html>
